public class UE11Aufgabe11 {

	static final int MAX_ZUEGE = 100;

	public static void main(String[] args) {
		try {

			// Feldgroesse erfragen
			int groesse = 0;
			do {
				System.out.println("Bitte Groesse des Feldes eingeben: ");
				groesse = IO.readInt();
			} while (groesse < 2 || groesse > 9);

			// Array fuer die Abspeicherung von Puan-Spielfeldern anlegen;
			// nach jedem Spielzug wird das neue Feld abgespeichert
			PuanFeld[] felder = new PuanFeld[UE11Aufgabe11.MAX_ZUEGE + 1];

			// Angangsfeld ist leer
			felder[0] = new PuanFeld(groesse);
			felder[0].print();
			int anzahl = 1;

			// Puan-Spiel durchfuehren
			// Spieler 1 beginnt
			boolean is_spieler1 = true;
			do {
				if (is_spieler1) {
					System.out.println("Spieler 1 am Zug!");
				} else {
					System.out.println("Spieler 2 am Zug!");
				}

				// naechster Spielzug
				int zeile = 0;
				do {
					System.out.println("Bitte Zeilennummer (0-" + (groesse - 1)
							+ ") eingeben: ");
					zeile = IO.readInt();
				} while (zeile < 0 || zeile >= groesse);
				int spalte = 0;
				do {
					System.out.println("Bitte Spaltennummer (0-"
							+ (groesse - 1) + ") eingeben: ");
					spalte = IO.readInt();
				} while (spalte < 0 || spalte >= groesse);

				// es wird ein Puan-Feld erzeugt, was der aktuellen
				// Spielsituation entspricht (altes Feld plus Spielzug)
				PuanFeld feld = new PuanFeld(felder[anzahl - 1]);
				feld.spielzug(zeile, spalte);
				feld.print();

				// Ueberpruefung des Spielzugs; alle bereits vorliegenden
				// und abgespeicherten Puan-Felder werden mit dem aktuellen
				// Feld auf Puan-Gleichheit verglichen
				for (int i = 0; i < anzahl; i++) {
					if (felder[i].puanGleich(feld)) {
						if (is_spieler1) {
							System.out.println("Spieler 1 hat verloren!");
						} else {
							System.out.println("Spieler 2 hat verloren!");
						}
						return; // Ende
					}
				}

				// Spielzug war ok, d.h. das aktuelle
				// Puan-Spielfeld wird abgespeichert
				felder[anzahl++] = feld;

				// Spieler wechselt
				is_spieler1 = !is_spieler1;
			} while (anzahl < UE11Aufgabe11.MAX_ZUEGE + 1);
			System.out.println("Unentschieden!");

		} catch (Exception obj) {
			System.out.println("Fehler: " + obj);
		}
	}
}

// Die Klasse PuanFeld implementiert die Datenstruktur zur
// Realisierung eines Puan-Spielfeldes sowie zur Ueberpruefung
// der Puan-Gleichheit zweier Puan-Spielfelder
class PuanFeld {

	boolean[][] matrix;

	// Stein gesetzt = true; Stein nicht gesetzt = false

	// leeres Feld
	PuanFeld(int groesse) {
		this.matrix = new boolean[groesse][groesse];
		for (int i = 0; i < groesse; i++) {
			for (int j = 0; j < groesse; j++) {
				this.matrix[i][j] = false;
			}
		}
	}

	// Copy-Konstruktor
	PuanFeld(PuanFeld feld) {
		this.matrix = new boolean[feld.matrix.length][feld.matrix.length];
		// neues Feld ist gleich altes Feld
		for (int i = 0; i < feld.matrix.length; i++) {
			for (int j = 0; j < feld.matrix.length; j++) {
				this.matrix[i][j] = feld.matrix[i][j];
			}
		}
	}

	// Spielzug durchfuehren
	void spielzug(int zeile, int spalte) {
		// der Wert des neuen Spielzugs wird festgehalten
		this.matrix[zeile][spalte] = !this.matrix[zeile][spalte];
	}

	// ueberprueft auf Puan-Gleichheit (incl. Rotationsgleichheit);
	// das als Parameter uebergebene Feld wird selbst nicht veraendert
	boolean puanGleich(PuanFeld feld) {
		// ueberpruefe alle 4 Stellungen
		for (int i = 0; i < 4; i++) {
			if (this.isGleich(feld)) {
				return true;
			}
			feld = feld.drehe();
		}
		return false;
	}

	// Spielfeld ausgeben
	void print() {
		System.out.print(" |");
		for (int i = 0; i < this.matrix.length; i++) {
			System.out.print(i + "|");
		}
		System.out.println();
		System.out.print("--");
		for (int i = 0; i < this.matrix.length; i++) {
			System.out.print("--");
		}
		System.out.println();
		for (int i = 0; i < this.matrix.length; i++) {
			System.out.print(i + "|");
			for (int j = 0; j < this.matrix.length; j++) {
				if (this.matrix[i][j]) {
					System.out.print("X|");
				} else {
					System.out.print(" |");
				}
			}
			System.out.println();
			System.out.print("--");
			for (int k = 0; k < this.matrix.length; k++) {
				System.out.print("--");
			}
			System.out.println();
		}
		System.out.println("*********************");
	}

	// drehe um 90 Grad nach rechts;
	// Achtung: Das Feld selbst wird nicht geaendert, stattdessen
	// wird ein gedrehtes Feld geliefert
	private PuanFeld drehe() {
		PuanFeld speicher = new PuanFeld(this.matrix.length);
		for (int i = 0; i < this.matrix.length; i++) {
			for (int j = 0; j < this.matrix.length; j++) {
				speicher.matrix[i][j] = this.matrix[this.matrix.length - 1 - j][i];
			}
		}
		return speicher;
	}

	// ueberprueft auf exakte Gleichheit
	private boolean isGleich(PuanFeld feld) {
		for (int i = 0; i < this.matrix.length; i++) {
			for (int j = 0; j < this.matrix.length; j++) {
				if (this.matrix[i][j] != feld.matrix[i][j]) {
					return false;
				}
			}
		}
		return true;
	}

}
