public class UE11Aufgabe14 {
	// Hauptprogramm
	public static void main(String[] args) {
		Umfrage umfrage = new Umfrage();
		umfrage.vorbereiten();
		umfrage.durchfuehren();
		umfrage.ergebnisseBekanntgeben();
	}
}

class Frage {
	String frage; // Fragetext
	int anzahlJa; // vermerken der Ja-Antworten
	int anzahlNein; // vermerken der Nein-Antworten

	public Frage(String frage) {
		this.frage = frage;
	}

	public String getFrage() {
		return this.frage;
	}

	public int getAnzahlJa() {
		return this.anzahlJa;
	}

	public int getAnzahlNein() {
		return this.anzahlNein;
	}

	public int gesamtAnzahlAnAntworten() {
		return this.getAnzahlJa() + this.getAnzahlNein();
	}

	public void neuesJa() {
		this.anzahlJa++;
	}

	public void neuesNein() {
		this.anzahlNein++;
	}

}

class Fragensammlung {
	Frage[] fragen; // Menge an Fragen
	String titel; // Titel der Umfrage
	int aktuellerIndex; // aktuelle Anzahl an Fragen-1
	int naechsterIndex; // Schleifenvariable

	// Konstruktor
	public Fragensammlung(String titel, int maxFragen) {
		this.titel = titel;
		this.aktuellerIndex = -1;
		this.fragen = new Frage[maxFragen];
		for (int i = 0; i < this.fragen.length; i++) {
			this.fragen[i] = null;
		}
		this.naechsterIndex = -1;
	}

	public String getTitel() {
		return this.titel;
	}

	// Frage hinzufuegen
	public void neueFrage(Frage f) {
		if (this.aktuellerIndex < this.fragen.length - 1) {
			this.fragen[++this.aktuellerIndex] = f;
		}
	}

	// liefert zyklisch die naechste Frage oder null, falls keine (mehr)
	// vorhanden ist
	public Frage liefereNaechsteFrage() {
		if (this.fragen.length == 0) {
			return null;
		}
		Frage f = null;
		if (this.naechsterIndex < this.aktuellerIndex) {
			f = this.fragen[++this.naechsterIndex];
		} else {
			this.naechsterIndex = -1; // bereite naechsten Zyklus vor
		}
		return f;
	}
}

class Umfrage {

	Fragensammlung umfrage; // die Fragensammlung

	public Umfrage() {
		this.umfrage = null;
	}

	public void vorbereiten() {
		IO.println("Fragen eingeben");
		IO.println("----------------");
		String titel = IO.readString("Titel der Umfrage: ");
		int anzahl = IO.readInt("Anzahl Fragen: ");
		this.umfrage = new Fragensammlung(titel, anzahl);
		// Fragen eingeben
		for (int i = 0; i < anzahl; i++) {
			String text = IO.readString("Frage " + (i + 1) + ": ");
			Frage f = new Frage(text);
			this.umfrage.neueFrage(f);
		}
	}

	public void durchfuehren() {
		IO.println("Umfrage");
		IO.println("--------");
		boolean weiter = IO.readChar("Weiterer Teilnehmer (j/n)?") == 'j';
		while (weiter) {
			Frage f = null;
			// alle Fragen der Pruefung stellen
			while ((f = this.umfrage.liefereNaechsteFrage()) != null) {
				IO.println(f.getFrage());
				char antwort = IO.readChar("ja/nein (j/n)?");
				if (antwort == 'j') {
					f.neuesJa();
				} else if (antwort == 'n') {
					f.neuesNein();
				}
			}
			weiter = IO.readChar("Weiterer Teilnehmer (j/n)?") == 'j';
		}
	}

	public void ergebnisseBekanntgeben() {
		IO.println("Umfrageergebnisse");
		IO.println("-----------------");
		IO.println("Umfrage: " + this.umfrage.getTitel());
		Frage f = null;
		// alle Fragen der Pruefung stellen
		while ((f = this.umfrage.liefereNaechsteFrage()) != null) {
			IO.println("Frage: " + f.getFrage());
			IO.println("ja-Antworten: " + f.getAnzahlJa() + " = " + 100.0
					* f.getAnzahlJa() / f.gesamtAnzahlAnAntworten()
					+ " Prozent");
			IO.println("nein-Antworten: " + f.getAnzahlNein() + " = " + 100.0
					* f.getAnzahlNein() / f.gesamtAnzahlAnAntworten()
					+ " Prozent");
		}
	}
}