public class UE11Aufgabe20 {

	public static void main(String[] args) {
		KalahSpiel kalah = new KalahSpiel();
		kalah.spielen();
	}

}

class KalahSpiel {

	KalahSpielfeld spielfeld;
	KalahSchiedsrichter schiedsrichter;
	KalahSpieler spielerA;
	KalahSpieler spielerB;

	KalahSpiel() {
		this.spielfeld = new KalahSpielfeld();
		this.schiedsrichter = new KalahSchiedsrichter(this);
		this.spielerA = new KalahSpieler(true);
		this.spielerB = new KalahSpieler(false);
	}

	KalahSpielfeld getSpielfeld() {
		return this.spielfeld;
	}

	KalahSchiedsrichter getSchiedsrichter() {
		return this.schiedsrichter;
	}

	KalahSpieler getSpielerA() {
		return this.spielerA;
	}

	KalahSpieler getSpielerB() {
		return this.spielerB;
	}

	void spielen() {
		this.spielfeld.print();
		KalahSpieler aktSpieler = this.schiedsrichter.getNaechsterSpieler();
		while (!this.schiedsrichter.istSpielBeendet()) {
			KalahSpielzug zug = aktSpieler.liefereNaechstenSpielzug();
			if (this.schiedsrichter.istSpielzugOk(zug)) {
				boolean nochmal = this.spielfeld.spielzugAusfuehren(zug);
				this.spielfeld.print();
				aktSpieler = this.schiedsrichter.getNaechsterSpieler(nochmal);
			} else {
				System.out
						.println("Spieler "
								+ aktSpieler.getName()
								+ " hat verloren, weil er sich nicht an die Spielregeln gehalten hat!");
				return;
			}
		}
		this.schiedsrichter.schlussZug();
		this.spielfeld.print();
		KalahSpieler sieger = this.schiedsrichter.getSieger();
		if (sieger != null) {
			System.out.println("Gewonnen hat Spieler " + sieger.getName());
		} else {
			System.out.println("Unentschieden!");
		}
	}
}

class KalahSpielfeld {
	static final int FELDER = 14;
	static final int KUGELN = 1;

	static final int MAX_LAENGE = KalahSpielfeld
			.laenge((KalahSpielfeld.FELDER - 2) * KalahSpielfeld.KUGELN);

	static final int KALAH_A = KalahSpielfeld.FELDER / 2 - 1;
	static final int MIN_A = 0;
	static final int MAX_A = KalahSpielfeld.FELDER / 2 - 2;
	static final int KALAH_B = KalahSpielfeld.FELDER - 1;
	static final int MIN_B = KalahSpielfeld.KALAH_A + 1;
	static final int MAX_B = KalahSpielfeld.FELDER - 2;

	int[] felder;

	KalahSpielfeld() {
		this.felder = new int[KalahSpielfeld.FELDER];
		for (int i = KalahSpielfeld.MIN_A; i <= KalahSpielfeld.MAX_A; i++) {
			this.felder[i] = KalahSpielfeld.KUGELN;
		}
		for (int i = KalahSpielfeld.MIN_B; i <= KalahSpielfeld.MAX_B; i++) {
			this.felder[i] = KalahSpielfeld.KUGELN;
		}
	}

	int getAnzahlKugeln(int lochIndex) {
		return this.felder[lochIndex];
	}

	void hinzufuegen(int lochIndex, int anzahl) {
		this.felder[lochIndex] += anzahl;
	}

	void leere(int lochIndex) {
		this.felder[lochIndex] = 0;
	}

	boolean spielzugAusfuehren(KalahSpielzug zug) {
		int startIndex = zug.getLochIndex();
		boolean istA = KalahSpielfeld.MIN_A <= startIndex
				&& startIndex <= KalahSpielfeld.MAX_A;

		// verteilen
		int kugeln = this.felder[startIndex];
		this.felder[startIndex] = 0;
		int index = (startIndex + 1) % KalahSpielfeld.FELDER;
		int endIndex = index;
		while (kugeln > 0) {
			if (istA) {
				if (index != KalahSpielfeld.KALAH_B) {
					this.felder[index]++;
					kugeln--;
					endIndex = index;
				}
			} else {
				if (index != KalahSpielfeld.KALAH_A) {
					this.felder[index]++;
					kugeln--;
					endIndex = index;
				}
			}
			index = (index + 1) % KalahSpielfeld.FELDER;
		}

		// evtl. uebertragen
		if (istA) {
			if (KalahSpielfeld.MIN_A <= endIndex
					&& endIndex <= KalahSpielfeld.MAX_A
					&& this.felder[endIndex] == 1
					&& this.felder[KalahSpielfeld
							.getGegenueberliegendesLoch(endIndex)] != 0) {
				this.felder[KalahSpielfeld.KALAH_A] += this.felder[endIndex];
				this.felder[KalahSpielfeld.KALAH_A] += this.felder[KalahSpielfeld
						.getGegenueberliegendesLoch(endIndex)];
				this.felder[endIndex] = 0;
				this.felder[KalahSpielfeld.getGegenueberliegendesLoch(endIndex)] = 0;
			}
		} else {
			if (KalahSpielfeld.MIN_B <= endIndex
					&& endIndex <= KalahSpielfeld.MAX_B
					&& this.felder[endIndex] == 1
					&& this.felder[KalahSpielfeld
							.getGegenueberliegendesLoch(endIndex)] != 0) {
				this.felder[KalahSpielfeld.KALAH_B] += this.felder[endIndex];
				this.felder[KalahSpielfeld.KALAH_B] += this.felder[KalahSpielfeld
						.getGegenueberliegendesLoch(endIndex)];
				this.felder[endIndex] = 0;
				this.felder[KalahSpielfeld.getGegenueberliegendesLoch(endIndex)] = 0;
			}
		}

		if (istA) {
			return endIndex == KalahSpielfeld.KALAH_A;
		} else {
			return endIndex == KalahSpielfeld.KALAH_B;
		}
	}

	void print() {
		// Index-Zeile Spieler A
		KalahSpielfeld.print(' ', KalahSpielfeld.MAX_LAENGE);
		for (int i = KalahSpielfeld.MAX_A; i >= KalahSpielfeld.MIN_A; i--) {
			KalahSpielfeld.print(i, KalahSpielfeld.MAX_LAENGE + 2);
		}
		System.out.println();

		// Loecher Spieler A
		KalahSpielfeld.print(' ', KalahSpielfeld.MAX_LAENGE);
		for (int i = KalahSpielfeld.MAX_A; i >= KalahSpielfeld.MIN_A; i--) {
			KalahSpielfeld.print(this.felder[i], KalahSpielfeld.MAX_LAENGE + 2);
		}
		System.out.println();

		// Kalahs
		KalahSpielfeld.print(this.felder[KalahSpielfeld.KALAH_A],
				KalahSpielfeld.MAX_LAENGE);
		for (int i = KalahSpielfeld.MIN_B; i <= KalahSpielfeld.MAX_B; i++) {
			KalahSpielfeld.print(' ', KalahSpielfeld.MAX_LAENGE + 2);
		}
		KalahSpielfeld.print(this.felder[KalahSpielfeld.KALAH_B],
				KalahSpielfeld.MAX_LAENGE);
		System.out.println();

		// Loecher Spieler B
		KalahSpielfeld.print(' ', KalahSpielfeld.MAX_LAENGE);
		for (int i = KalahSpielfeld.MIN_B; i <= KalahSpielfeld.MAX_B; i++) {
			KalahSpielfeld.print(this.felder[i], KalahSpielfeld.MAX_LAENGE + 2);
		}
		System.out.println();

		// Index-Zeile Spieler B
		KalahSpielfeld.print(' ', KalahSpielfeld.MAX_LAENGE);
		for (int i = KalahSpielfeld.MIN_B; i <= KalahSpielfeld.MAX_B; i++) {
			KalahSpielfeld.print(i, KalahSpielfeld.MAX_LAENGE + 2);
		}
		System.out.println();
		System.out.println();
		System.out.println();
	}

	static int getGegenueberliegendesLoch(int index) {
		return KalahSpielfeld.FELDER - 2 - index;
	}

	static void print(char ch, int anzahl) {
		for (int i = 0; i < anzahl; i++) {
			System.out.print(ch);
		}
	}

	static void print(int zahl, int laenge) {
		System.out.print(zahl);
		KalahSpielfeld.print(' ', laenge - KalahSpielfeld.laenge(zahl));
	}

	static int laenge(int zahl) {
		if (zahl < 10) {
			return 1;
		} else {
			return 1 + KalahSpielfeld.laenge(zahl / 10);
		}
	}

}

class KalahSpieler {

	boolean istA;

	KalahSpieler(boolean a) {
		this.istA = a;
	}

	boolean istA() {
		return this.istA;
	}

	KalahSpielzug liefereNaechstenSpielzug() {
		int eingabe = IO.readInt("Spieler " + this.getName()
				+ ", Lochindex eingeben: ");
		return new KalahSpielzug(eingabe);
	}

	String getName() {
		return this.istA ? "A" : "B";
	}

}

class KalahSchiedsrichter {

	KalahSpiel spiel;
	KalahSpieler aktSpieler;

	KalahSchiedsrichter(KalahSpiel spiel) {
		this.spiel = spiel;
		this.aktSpieler = null;
	}

	boolean istSpielzugOk(KalahSpielzug zug) {
		if (this.aktSpieler.istA()) {
			if (zug.getLochIndex() < KalahSpielfeld.MIN_A
					|| zug.getLochIndex() > KalahSpielfeld.MAX_A) {
				return false;
			}
		} else {
			if (zug.getLochIndex() < KalahSpielfeld.MIN_B
					|| zug.getLochIndex() > KalahSpielfeld.MAX_B) {
				return false;
			}
		}
		if (this.spiel.getSpielfeld().getAnzahlKugeln(zug.getLochIndex()) == 0) {
			return false;
		}
		return true;
	}

	boolean istSpielBeendet() {
		int kugeln = 0;
		for (int i = KalahSpielfeld.MIN_A; i <= KalahSpielfeld.MAX_A; i++) {
			kugeln += this.spiel.getSpielfeld().getAnzahlKugeln(i);
		}
		if (kugeln == 0) {
			return true;
		}

		kugeln = 0;
		for (int i = KalahSpielfeld.MIN_B; i <= KalahSpielfeld.MAX_B; i++) {
			kugeln += this.spiel.getSpielfeld().getAnzahlKugeln(i);
		}
		if (kugeln == 0) {
			return true;
		}

		return false;
	}

	KalahSpieler getSieger() {
		KalahSpielfeld feld = this.spiel.getSpielfeld();
		int diff = feld.getAnzahlKugeln(KalahSpielfeld.KALAH_A)
				- feld.getAnzahlKugeln(KalahSpielfeld.KALAH_B);
		if (diff > 0) {
			return this.spiel.getSpielerA();
		} else if (diff < 0) {
			return this.spiel.getSpielerB();
		} else {
			return null;
		}
	}

	KalahSpieler getNaechsterSpieler() {
		if (this.aktSpieler == null) {
			this.aktSpieler = this.spiel.getSpielerA();
		} else if (this.aktSpieler.istA()) {
			this.aktSpieler = this.spiel.getSpielerB();
		} else {
			this.aktSpieler = this.spiel.getSpielerA();
		}
		return this.aktSpieler;
	}

	KalahSpieler getNaechsterSpieler(boolean nochmal) {
		if (!nochmal) {
			this.aktSpieler = this.getNaechsterSpieler();
		} else if (this.aktSpieler == null) {
			this.aktSpieler = this.spiel.getSpielerA();
		} else if (this.aktSpieler.istA()) {
			this.aktSpieler = this.spiel.getSpielerA();
		} else {
			this.aktSpieler = this.spiel.getSpielerB();
		}
		return this.aktSpieler;
	}

	void schlussZug() {
		for (int i = KalahSpielfeld.MIN_A; i <= KalahSpielfeld.MAX_A; i++) {
			this.spiel.getSpielfeld().hinzufuegen(KalahSpielfeld.KALAH_A,
					this.spiel.getSpielfeld().getAnzahlKugeln(i));
			this.spiel.getSpielfeld().leere(i);
		}
	}

}

class KalahSpielzug {

	int lochIndex;

	KalahSpielzug(int index) {
		this.lochIndex = index;
	}

	int getLochIndex() {
		return this.lochIndex;
	}

}
