public class UE11Aufgabe23 {

	public static void main(String[] args) {
		ParobSpieler weiss = new ParobSpieler(ParobFigur.WEISS);
		ParobSpieler schwarz = new ParobSpieler(ParobFigur.SCHWARZ);
		ParobBrett brett = new ParobBrett();
		ParobRegeln regeln = new ParobRegeln(brett, weiss, schwarz);

		ParobSpiel parob = new ParobSpiel(weiss, schwarz, brett, regeln);
		parob.spielen();
	}

}

// -----------------------------------------------------
// Klasse ParobSpiel
// -----------------------------------------------------
class ParobSpiel {

	// Attribute
	ParobSpieler spielerWeiss, spielerSchwarz;
	ParobBrett brett;
	ParobRegeln regeln;

	// Methoden

	// Konstruktor (Initialisierung eines Spiels)
	public ParobSpiel(ParobSpieler a, ParobSpieler b, ParobBrett brett,
			ParobRegeln regeln) {
		this.spielerWeiss = a;
		this.spielerSchwarz = b;
		this.brett = brett;
		this.regeln = regeln;
	}

	// Durchfuehrung eines Spiels
	public void spielen() {
		// Spieler Weiss beginnt
		ParobSpieler aktSpieler = this.spielerWeiss;
		ParobSpielzug zug = null;
		this.brett.gebeSpielbrettAus();

		// abwechselndes Ziehen bis Spielende erreicht ist
		do {
			if (aktSpieler == this.spielerWeiss)
				System.out.println("Spieler Weiss ist am Zug!");
			else
				System.out.println("Spieler Schwarz ist am Zug!");

			// legalen Spielzug ermitteln und ausfuehren
			zug = aktSpieler.liefereNaechstenSpielzug(zug);
			while (!this.regeln.spielzugOK(zug, aktSpieler)) {
				System.out.println("Ungueltig; neue Eingabe!");
				zug = aktSpieler.liefereNaechstenSpielzug(zug);
			}
			this.brett.fuehreSpielzugAus(zug);
			this.brett.gebeSpielbrettAus();

			// der andere Spieler ist nun am Zug
			if (aktSpieler == spielerWeiss)
				aktSpieler = this.spielerSchwarz;
			else
				aktSpieler = this.spielerWeiss;
		} while (!this.regeln.spielEnde());

		// Spiel ist zuende
		this.regeln.gebeSiegerBekannt();
	}

	// Hauptprogramm;
	// hier startet das Parob-Programm
	public static void main(String[] args) {
		ParobSpieler weiss = new ParobSpieler(ParobFigur.WEISS);
		ParobSpieler schwarz = new ParobSpieler(ParobFigur.SCHWARZ);
		ParobBrett brett = new ParobBrett();
		ParobRegeln regeln = new ParobRegeln(brett, weiss, schwarz);

		ParobSpiel parob = new ParobSpiel(weiss, schwarz, brett, regeln);
		parob.spielen();
	}
}

// -----------------------------------------------------
// Klasse ParobBrett
// -----------------------------------------------------
class ParobBrett {

	/*
	 * gewaehlte Datenstruktur:
	 * 
	 * 0 1 2 3 4 5 6 +-+ 0 |b| +-+-+-+-+ 1 |r|b|b|r| +-+-+-+-+-+ 2 |p|p|p|p|p|
	 * +-+-+-+-+-+-+ 3 | | | | | | | +-+-+-+-+-+-+-+ 4 | | | | | | | |
	 * +-+-+-+-+-+-+-+ 5 | | | | | | | +-+-+-+-+-+-+ 6 |P|P|P|P|P| +-+-+-+-+-+ 7
	 * |R|B|B|R| +-+-+-+-+ 8 |B| +-+
	 * 
	 * repraesentiert als 9 x 7 - Matrix; fehlende Felder == null
	 * 
	 * Fuer die Spieler werden die Felder von oben nach unten, links nach rechts
	 * von 1 bis 39 durchnummeriert
	 */

	// Attribute
	ParobFeld[][] brett;

	// Methoden
	// Konstruktor (Initialisierung des Parob-Brettes)
	public ParobBrett() {
		this.brett = new ParobFeld[9][7];
		for (int z = 0; z < 9; z++)
			for (int s = 0; s < 7; s++)
				this.brett[z][s] = null;

		// leere Felder
		for (int s = 1; s < 7; s++)
			this.brett[3][s] = new ParobFeld();

		for (int s = 0; s < 7; s++)
			this.brett[4][s] = new ParobFeld();

		for (int s = 0; s < 6; s++)
			this.brett[5][s] = new ParobFeld();

		// mit schwarzen Figuren besetzte Felder
		this.brett[0][5] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.LAEUFER_SCHWARZ, 0, 5, this));
		this.brett[1][3] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.TURM_SCHWARZ, 1, 3, this));
		this.brett[1][4] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.LAEUFER_SCHWARZ, 1, 4, this));
		this.brett[1][5] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.LAEUFER_SCHWARZ, 1, 5, this));
		this.brett[1][6] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.TURM_SCHWARZ, 1, 6, this));
		this.brett[2][2] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.BAUER_SCHWARZ, 2, 2, this));
		this.brett[2][3] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.BAUER_SCHWARZ, 2, 3, this));
		this.brett[2][4] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.BAUER_SCHWARZ, 2, 4, this));
		this.brett[2][5] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.BAUER_SCHWARZ, 2, 5, this));
		this.brett[2][6] = new ParobFeld(new ParobFigur(ParobFigur.SCHWARZ,
				ParobFigur.BAUER_SCHWARZ, 2, 6, this));

		// mit weissen Figuren besetzte Felder
		this.brett[6][0] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.BAUER_WEISS, 6, 0, this));
		this.brett[6][1] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.BAUER_WEISS, 6, 1, this));
		this.brett[6][2] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.BAUER_WEISS, 6, 2, this));
		this.brett[6][3] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.BAUER_WEISS, 6, 3, this));
		this.brett[6][4] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.BAUER_WEISS, 6, 4, this));
		this.brett[7][0] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.TURM_WEISS, 7, 0, this));
		this.brett[7][1] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.LAEUFER_WEISS, 7, 1, this));
		this.brett[7][2] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.LAEUFER_WEISS, 7, 2, this));
		this.brett[7][3] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.TURM_WEISS, 7, 3, this));
		this.brett[8][1] = new ParobFeld(new ParobFigur(ParobFigur.WEISS,
				ParobFigur.LAEUFER_WEISS, 8, 1, this));
	}

	// Ausfuehrung eines Spielzugs auf dem Brett
	public void fuehreSpielzugAus(ParobSpielzug zug) {
		ParobPosition von = ParobSpielzug.umrechnung(zug.vonWo());
		ParobPosition nach = ParobSpielzug.umrechnung(zug.nachWo());
		ParobFigur figur = this.brett[von.zeile][von.spalte].entferneFigur();
		this.brett[nach.zeile][nach.spalte].setzeFigur(figur);
	}

	// Ausgabe des aktuellen Spielbretts
	public void gebeSpielbrettAus() {

		System.out.println("              / \\                ");
		System.out.println("             | " + liefereZeichen(0, 5)
				+ " |               (1)");
		System.out.println("        / \\ / \\ / \\ / \\          ");
		System.out.println("       | " + liefereZeichen(1, 3) + " | "
				+ liefereZeichen(1, 4) + " | " + liefereZeichen(1, 5) + " | "
				+ liefereZeichen(1, 6) + " |         (2 - 5)");
		System.out.println("      / \\ / \\ / \\ / \\ / \\        ");
		System.out.println("     | " + liefereZeichen(2, 2) + " | "
				+ liefereZeichen(2, 3) + " | " + liefereZeichen(2, 4) + " | "
				+ liefereZeichen(2, 5) + " | " + liefereZeichen(2, 6)
				+ " |       (6 - 10)");
		System.out.println("    / \\ / \\ / \\ / \\ / \\ / \\      ");
		System.out.println("   | " + liefereZeichen(3, 1) + " | "
				+ liefereZeichen(3, 2) + " | " + liefereZeichen(3, 3) + " | "
				+ liefereZeichen(3, 4) + " | " + liefereZeichen(3, 5) + " | "
				+ liefereZeichen(3, 6) + " |     (11 - 16)");
		System.out.println("  / \\ / \\ / \\ / \\ / \\ / \\ / \\    ");
		System.out.println(" | " + liefereZeichen(4, 0) + " | "
				+ liefereZeichen(4, 1) + " | " + liefereZeichen(4, 2) + " | "
				+ liefereZeichen(4, 3) + " | " + liefereZeichen(4, 4) + " | "
				+ liefereZeichen(4, 5) + " | " + liefereZeichen(4, 6)
				+ " \\   (17 - 23)");
		System.out.println("  \\ / \\ / \\ / \\ / \\ / \\ / \\ /    ");
		System.out.println("   | " + liefereZeichen(5, 0) + " | "
				+ liefereZeichen(5, 1) + " | " + liefereZeichen(5, 2) + " | "
				+ liefereZeichen(5, 3) + " | " + liefereZeichen(5, 4) + " | "
				+ liefereZeichen(5, 5) + " |     (24 - 29)");
		System.out.println("    \\ / \\ / \\ / \\ / \\ / \\ /      ");
		System.out.println("     | " + liefereZeichen(6, 0) + " | "
				+ liefereZeichen(6, 1) + " | " + liefereZeichen(6, 2) + " | "
				+ liefereZeichen(6, 3) + " | " + liefereZeichen(6, 4)
				+ " |       (30 - 34)");
		System.out.println("      \\ / \\ / \\ / \\ / \\ /        ");
		System.out.println("       | " + liefereZeichen(7, 0) + " | "
				+ liefereZeichen(7, 1) + " | " + liefereZeichen(7, 2) + " | "
				+ liefereZeichen(7, 3) + " |         (35 - 38)");
		System.out.println("        \\ / \\ / \\ / \\            ");
		System.out.println("             | " + liefereZeichen(8, 1)
				+ " |               (39)");
		System.out.println("              \\ /                ");

	}

	// Lieferung der Figur an der Stelle z/s
	public ParobFeld liefereFeld(int z, int s) {
		return this.brett[z][s];
	}

	// Lieferung des Figurzeichens oder Leerzeichen, falls
	// leeres Feld
	public char liefereZeichen(int z, int s) {
		if (this.brett[z][s].istLeer()) {
			return ' ';
		} else {
			return this.brett[z][s].liefereFigur().welcherTyp();
		}
	}

}

// -----------------------------------------------------
// Klasse ParobFeld
// -----------------------------------------------------
class ParobFeld {

	ParobFigur figur;

	public ParobFeld() {
		// leeres Feld
		this.figur = null;
	}

	public ParobFeld(ParobFigur figur) {
		this.figur = figur;
	}

	public ParobFigur liefereFigur() {
		return this.figur;
	}

	public boolean istLeer() {
		return this.figur == null;
	}

	public ParobFigur entferneFigur() {
		ParobFigur fig = this.figur;
		this.figur = null;
		return fig;
	}

	public void setzeFigur(ParobFigur figur) {
		this.figur = figur;
	}

}

// -----------------------------------------------------
// Klasse ParobFigur
// -----------------------------------------------------
class ParobFigur {

	// Konstanten
	public final static boolean WEISS = true;
	public final static boolean SCHWARZ = !WEISS;

	public final static char BAUER_WEISS = 'P';
	public final static char TURM_WEISS = 'R';
	public final static char LAEUFER_WEISS = 'B';

	public final static char BAUER_SCHWARZ = 'p';
	public final static char TURM_SCHWARZ = 'r';
	public final static char LAEUFER_SCHWARZ = 'b';

	// Attribute
	boolean istWeiss;
	char typ;
	int zeile;
	int spalte;
	boolean kannBurgErobern;
	ParobBrett brett;

	// Methoden
	// Konstruktor (Initialisierung einer Figur)
	public ParobFigur(boolean istWeiss, char typ, int zeile, int spalte,
			ParobBrett brett) {
		this.istWeiss = istWeiss;
		this.typ = typ;
		this.zeile = zeile;
		this.spalte = spalte;
		this.brett = brett;
		if (typ == BAUER_WEISS || typ == BAUER_SCHWARZ || typ == TURM_WEISS
				|| typ == TURM_SCHWARZ
				|| (typ == LAEUFER_WEISS && zeile == 8 && spalte == 1)
				|| (typ == LAEUFER_SCHWARZ && zeile == 0 && spalte == 5)) {
			this.kannBurgErobern = true;
		} else {
			this.kannBurgErobern = false;
		}

	}

	public boolean istWeiss() {
		return this.istWeiss;
	}

	public int welcheZeile() {
		return this.zeile;
	}

	public int welcheSpalte() {
		return this.spalte;
	}

	public char welcherTyp() {
		return this.typ;
	}

	public boolean kannBurgErobern() {
		return this.kannBurgErobern;
	}

}

// -----------------------------------------------------
// Klasse ParobSpielzug
// -----------------------------------------------------

class ParobPosition {
	int zeile;
	int spalte;
}

class ParobSpielzug {

	// Attribute
	int von; // 1 - 39
	int nach; // 1 - 39

	// Methoden
	// Konstruktor (Initialisierung eines Spielzugs)
	public ParobSpielzug(int von, int nach) {
		this.von = von;
		this.nach = nach;
	}

	public int vonWo() {
		return this.von;
	}

	public int nachWo() {
		return this.nach;
	}

	// Umrechnung in interne Koordinaten
	public static ParobPosition umrechnung(int feld) {
		ParobPosition erg = new ParobPosition();
		if (feld == 1) {
			erg.zeile = 0;
			erg.spalte = 5;
		} else if (feld <= 5) {
			erg.zeile = 1;
			erg.spalte = feld + 1;
		} else if (feld <= 10) {
			erg.zeile = 2;
			erg.spalte = feld - 4;
		} else if (feld <= 16) {
			erg.zeile = 3;
			erg.spalte = feld - 10;
		} else if (feld <= 23) {
			erg.zeile = 4;
			erg.spalte = feld - 17;
		} else if (feld <= 29) {
			erg.zeile = 5;
			erg.spalte = feld - 24;
		} else if (feld <= 34) {
			erg.zeile = 6;
			erg.spalte = feld - 30;
		} else if (feld <= 38) {
			erg.zeile = 7;
			erg.spalte = feld - 35;
		} else {
			erg.zeile = 8;
			erg.spalte = 1;
		}
		return erg;
	}

}

// -----------------------------------------------------
// Klasse ParobRegeln
// -----------------------------------------------------
class ParobRegeln {

	// Attribute
	ParobBrett brett;
	ParobSpieler weiss;
	ParobSpieler schwarz;
	String sieger;

	// Methoden
	// Konstruktor (Initialisierung der Regeln)
	public ParobRegeln(ParobBrett brett, ParobSpieler weiss,
			ParobSpieler schwarz) {
		this.brett = brett;
		this.weiss = weiss;
		this.schwarz = schwarz;
		this.sieger = null;
	}

	// Ueberpruefung eines Spielzugs
	public boolean spielzugOK(ParobSpielzug zug, ParobSpieler spieler) {
		// Feld zwischen 1 und 39 ?
		if (zug.vonWo() < 1 || zug.vonWo() > 39 || zug.nachWo() < 1
				|| zug.nachWo() > 39) {
			return false;
		}

		ParobPosition von = ParobSpielzug.umrechnung(zug.vonWo());
		ParobPosition nach = ParobSpielzug.umrechnung(zug.nachWo());

		// steht auf dem angegebenen Feld eine korrekte Figur ?
		ParobFeld vonFeld = this.brett.liefereFeld(von.zeile, von.spalte);
		if (vonFeld.istLeer()
				|| (spieler.istWeiss() != vonFeld.liefereFigur().istWeiss())) {
			return false;
		}

		// eigene Figuren koennen nicht geschlagen werden
		ParobFeld nachFeld = this.brett.liefereFeld(nach.zeile, nach.spalte);
		if (!nachFeld.istLeer()
				&& (spieler.istWeiss() == nachFeld.liefereFigur().istWeiss())) {
			return false;
		}

		// Figurenzuege ueberpruefen
		ParobFigur figur = vonFeld.liefereFigur();
		switch (figur.welcherTyp()) {
		case ParobFigur.TURM_WEISS:
		case ParobFigur.TURM_SCHWARZ:
			// richtige Zeile und Spalte
			if (!(von.zeile == nach.zeile || von.spalte == nach.spalte || (von.zeile
					+ von.spalte == nach.zeile + nach.spalte))) {
				return false;
			}
			// Ueberspringen
			if (von.zeile == nach.zeile) {
				for (int i = Math.min(von.spalte, nach.spalte) + 1; i <= Math
						.max(von.spalte, nach.spalte) - 1; i++) {
					if (i != von.spalte
							&& !this.brett.liefereFeld(von.zeile, i).istLeer()) {
						return false;
					}
				}
			} else if (von.spalte == nach.spalte) {
				for (int i = Math.min(von.zeile, nach.zeile) + 1; i <= Math
						.max(von.zeile, nach.zeile) - 1; i++) {
					if (i != von.zeile
							&& !this.brett.liefereFeld(i, von.spalte).istLeer()) {
						return false;
					}
				}
			} else { // Diagonale
				for (int i = Math.min(von.zeile, nach.zeile) + 1; i <= Math
						.max(von.zeile, nach.zeile) - 1; i++) {
					int j = (von.zeile + von.spalte) - i;
					if (i != von.zeile && j != von.spalte
							&& !this.brett.liefereFeld(i, j).istLeer()) {
						return false;
					}
				}
			}
			break;
		case ParobFigur.LAEUFER_WEISS:
		case ParobFigur.LAEUFER_SCHWARZ:
			if (!((nach.zeile == von.zeile + 2 && nach.spalte == von.spalte - 1)
					|| (nach.zeile == von.zeile + 1 && nach.spalte == von.spalte - 2)
					|| (nach.zeile == von.zeile + 1 && nach.spalte == von.spalte + 1)
					|| (nach.zeile == von.zeile - 1 && nach.spalte == von.spalte - 1)
					|| (nach.zeile == von.zeile - 1 && nach.spalte == von.spalte + 2) || (nach.zeile == von.zeile - 2 && nach.spalte == von.spalte + 1))) {
				return false;
			}
			break;
		case ParobFigur.BAUER_WEISS:
			if (!(nach.zeile == von.zeile - 1 && (nach.spalte == von.spalte || nach.spalte == von.spalte + 1))) {
				// Ausnahmefall vorletzte Zeile
				if (!(von.zeile == 1 && nach.zeile == 1 && (von.spalte == 3
						&& nach.spalte == 4 || von.spalte == 6
						&& nach.spalte == 5))) {
					return false;
				}
			}
			break;
		case ParobFigur.BAUER_SCHWARZ:
			if (!(nach.zeile == von.zeile + 1 && (nach.spalte == von.spalte || nach.spalte == von.spalte - 1))) {
				// Ausnahmefall vorletzte Zeile
				if (!(von.zeile == 7 && nach.zeile == 7 && (von.spalte == 0
						&& nach.spalte == 1 || von.spalte == 3
						&& nach.spalte == 2))) {
					return false;
				}
			}
			break;
		}

		return true;
	}

	// Ueberpruefung des Spielendes
	public boolean spielEnde() {
		// Burg erobert?
		ParobFeld burgSchwarz = this.brett.liefereFeld(0, 5);
		if (!burgSchwarz.istLeer() && burgSchwarz.liefereFigur().istWeiss()) {
			this.sieger = "Burg besetzt! Sieger ist Spieler Weiss!";
			return true;
		}
		ParobFeld burgWeiss = this.brett.liefereFeld(8, 1);
		if (!burgWeiss.istLeer() && !burgWeiss.liefereFigur().istWeiss()) {
			this.sieger = "Burg besetzt! Sieger ist Spieler Schwarz!";
			return true;
		}

		// kann noch die Burg erobert werden?
		if (!kannNochGewinnen(this.weiss)) {
			this.sieger = "Keine Chance mehr! Sieger ist Spieler Schwarz!";
			return true;
		}
		if (!kannNochGewinnen(this.schwarz)) {
			this.sieger = "Keine Chance mehr! Sieger ist Spieler Weiss!";
			return true;
		}

		// Anmerkung: Die zweite Zusatzregel kann gestrichen werden.
		// Es koennen keine Zustaende auftreten, in denen keine
		// legalen Spielzuege mehr moeglich sind

		return false;
	}

	// Ausgabe des Siegers
	public void gebeSiegerBekannt() {
		System.out.println(this.sieger);
	}

	// kann noch die gegnerische Burg erobert werden?
	public boolean kannNochGewinnen(ParobSpieler spieler) {
		for (int z = 0; z < 9; z++) {
			for (int s = 0; s < 7; s++) {
				if (this.brett.liefereFeld(z, s) != null
						&& !this.brett.liefereFeld(z, s).istLeer()
						&& (this.brett.liefereFeld(z, s).liefereFigur()
								.istWeiss() == spieler.istWeiss())
						&& this.brett.liefereFeld(z, s).liefereFigur()
								.kannBurgErobern()) {
					return true;
				}
			}
		}
		return false;
	}

}

// -----------------------------------------------------
// Klasse ParobSpieler
// -----------------------------------------------------

class ParobSpieler {

	// Attribute
	boolean istWeiss;

	// Methoden
	// Konstruktor (Initialisierung eines Spielers)
	public ParobSpieler(boolean istWeiss) {
		this.istWeiss = istWeiss;
	}

	// Ueberpruefung, ob es Spieler A ist
	public boolean istWeiss() {
		return this.istWeiss;
	}

	// erfragt und liefert naechsten Spielzug des
	// Spielers; uebergeben wird der letzte Zug des
	// Gegners
	public ParobSpielzug liefereNaechstenSpielzug(ParobSpielzug gegnerZug) {
		return this.erfrageNaechstenSpielzugBeimSpieler();
	}

	// erfragt naechsten Spielzug beim Spieler
	public ParobSpielzug erfrageNaechstenSpielzugBeimSpieler() {
		System.out.println("von Feld (1-39): ");
		int von = IO.readInt();
		System.out.println("nach Feld (1-39): ");
		int nach = IO.readInt();
		return new ParobSpielzug(von, nach);
	}

}
