class Blatt {
	String text;

	Blatt() { // Default-Konstruktor
		text = "";
	}

	Blatt(Blatt b) { // Copy-Konstruktor
		if (b != null) {
			this.text = b.text;
		} else {
			text = "";
		}
	}

	void beschreiben(String text) {
		if (text == null) {
			text = "";
		}
		this.text = text;
	}

	String lesen() {
		return this.text;
	}

}

class Kopierer {

	int anzahlKopien;
	Blatt blatt;

	void blattEinlegen(Blatt blatt) {
		this.blatt = blatt;
	}

	void kopienEinstellen(int anzahl) {
		this.anzahlKopien = anzahl;
	}

	Blatt[] kopieren() {
		if (anzahlKopien <= 0 || blatt == null) {
			return new Blatt[0];
		}
		Blatt[] kopien = new Blatt[anzahlKopien];
		for (int i = 0; i < kopien.length; i++) {
			kopien[i] = new Blatt(blatt); // wichtig Kopie!
		}
		return kopien;
	}
}

public class UE11Aufgabe28 {

	public static void main(String[] args) {
		Kopierer k = new Kopierer();
		Blatt klausur = new Blatt();
		klausur.beschreiben("Klausur A");
		k.kopienEinstellen(5);
		k.blattEinlegen(klausur);
		Blatt[] kopien = k.kopieren();
		for (Blatt b : kopien) {
			System.out.println(b.lesen());
		}
	}
}
